#!/usr/bin/perl -w
######################################################################
# Michael Schilli, 1998 (mschilli@perlmeister.com)
######################################################################

use CGI qw/:standard/;                          # Cgi-Funktionen
use Fcntl qw/:flock/;                           # LOCK_EX

print header();                                 # Header ausgeben

%products = (1 => 'Perl fu^r Frauen, O\'Reilly, DM 59.90', # Produkte
             2 => 'Perl in 3 Tagen, SamsNet, DM 18.90', 
             3 => 'Go To Perl5, AWL, DM 59.00');

eval {                                          # Fehler abfangen

  if(!defined param('kundennummer')) {          # Keine Kundennummer?
      print start_html('-title', 'Willkommen'), # -> Startseite
            h1('Willkommen im Perl-Buchladen!'),
            start_form(), "Ihre Kundennummer:", 
            textfield(-name => 'kundennummer'),
            submit(-value => "Einkaufen geh'n!"),
            end_form(), end_html();

  } elsif(!defined param('bestellung')) {       # Keine Bestellung?
      print start_html('-title', 'Bestellung'), # -> Bestellseite
            h1("Unser Sortiment:"), start_form(),
            checkbox_group(
                '-name'      => 'bestellung',
                '-values'    =>  [keys %products],
                '-linebreak' => 'true',         # Untereinander
                '-labels'    => \%products),    # Produkte
            p(), submit(-value => 'Bestellen'), # Bestellknopf
            hidden(-name  => 'kundennummer'),   # Weiterreichen
            end_form(), end_html();

  } else {                                      # Bestellung speichern
      open(ORDER, ">>orders.txt") || die "Cannot open orders.txt";
      flock(ORDER, LOCK_EX);                    # Lock setzen
      print ORDER "Kundennummer: ", param('kundennummer'),
                  " Bestellung: ", $products{param('bestellung')}, "\n";
      close(ORDER);
  
      print start_html('-title', 'Danke!'),     # Danke!-Seite
            p(), "Vielen Dank. ", 
            i($products{param('bestellung')}), 
            " geht Ihnen in den nchsten Tagen zu.", p(),
            p(), "Der fllige Betrag wird mit Kundennummer ", 
            param('kundennummer'), " verrechnet.",
            p(), "Viel Spa damit!",
            start_form(), submit(-value => "Zurck zum Eingang"),
            end_form(), end_html();
  }
};

if ($@) {                                       # Fehler?
    print "Unser System kann Ihre Order leider momentan nicht " .
          "entgegennehmen. Bitte versuchen Sie es spter nochmal.\n";
    open(ERRORLOG, ">>/tmp/errorlog");
    print ERRORLOG scalar localtime, "> $@";
    close(ERRORLOG);
}
